OpenVDB: Vec3< T > Class Template Reference

OpenVDB 10.0.1

Loading...
Searching...
No Matches
Public Types | Public Member Functions | Static Public Member Functions | Static Public Attributes | List of all members
Vec3< T > Class Template Reference

`#include <openvdb/math/Vec3.h>`

Inheritance diagram for Vec3< T >:

## Public Types
using | value_type = T
using | ValueType = T

## Public Member Functions
| Vec3 ()=default
| Vec3 (T val)
| Construct a vector all of whose components have the given value.
| Vec3 (T x, T y, T z)
| Constructor with three arguments, e.g. Vec3d v(1,2,3);.
template<typename Source >
| Vec3 (Source *a)
| Constructor with array argument, e.g. double a[3]; Vec3d v(a);.
template<typename Source >
| Vec3 (const Tuple< 3, Source > &v)
| Construct a Vec3 from a 3-Tuple with a possibly different value type.
template<typename Other >
| Vec3 (Other val, typename std::enable_if< std::is_arithmetic< Other >::value, Conversion >::type=Conversion{})
| Construct a vector all of whose components have the given value, which may be of an arithmetic type different from this vector's value type.
template<typename Other >
| Vec3 (const Vec3< Other > &v)
| Construct a Vec3 from another Vec3 with a possibly different value type.
T & | x ()
| Reference to the component, e.g. v.x() = 4.5f;.
T & | y ()
T & | z ()
T | x () const
| Get the component, e.g. float f = v.y();.
T | y () const
T | z () const
T * | asPointer ()
const T * | asPointer () const
T & | operator() (int i)
| Alternative indexed reference to the elements.
T | operator() (int i) const
| Alternative indexed constant reference to the elements,.
const Vec3< T > & | init (T x=0, T y=0, T z=0)
const Vec3< T > & | setZero ()
| Set "this" vector to zero.
template<typename Source >
const Vec3< T > & | operator= (const Vec3< Source > &v)
| Assignment operator.
bool | eq (const Vec3< T > &v, T eps=static_cast< T >(1.0e-7)) const
| Test if "this" vector is equivalent to vector v with tolerance of eps.
Vec3< T > | operator- () const
| Negation operator, for e.g. v1 = -v2;.
template<typename T0 , typename T1 >
const Vec3< T > & | add (const Vec3< T0 > &v1, const Vec3< T1 > &v2)
template<typename T0 , typename T1 >
const Vec3< T > & | sub (const Vec3< T0 > &v1, const Vec3< T1 > &v2)
template<typename T0 , typename T1 >
const Vec3< T > & | scale (T0 scale, const Vec3< T1 > &v)
template<typename T0 , typename T1 >
const Vec3< T > & | div (T0 scale, const Vec3< T1 > &v)
T | dot (const Vec3< T > &v) const
| Dot product.
T | length () const
| Length of the vector.
T | lengthSqr () const
Vec3< T > | cross (const Vec3< T > &v) const
| Return the cross product of "this" vector and v;.
const Vec3< T > & | cross (const Vec3< T > &v1, const Vec3< T > &v2)
| this = v1 cross v2, v1 and v2 must be distinct objects than "this"
template<typename S >
const Vec3< T > & | operator*= (S scalar)
| Multiply each element of this vector by scalar.
template<typename S >
const Vec3< T > & | operator*= (const Vec3< S > &v1)
| Multiply each element of this vector by the corresponding element of the given vector.
template<typename S >
const Vec3< T > & | operator/= (S scalar)
| Divide each element of this vector by scalar.
template<typename S >
const Vec3< T > & | operator/= (const Vec3< S > &v1)
| Divide each element of this vector by the corresponding element of the given vector.
template<typename S >
const Vec3< T > & | operator+= (S scalar)
| Add scalar to each element of this vector.
template<typename S >
const Vec3< T > & | operator+= (const Vec3< S > &v1)
| Add each element of the given vector to the corresponding element of this vector.
template<typename S >
const Vec3< T > & | operator-= (S scalar)
| Subtract scalar from each element of this vector.
template<typename S >
const Vec3< T > & | operator-= (const Vec3< S > &v1)
| Subtract each element of the given vector from the corresponding element of this vector.
const Vec3< T > & | exp ()
const Vec3< T > & | log ()
T | sum () const
| Return the sum of all the vector components.
T | product () const
| Return the product of all the vector components.
bool | normalize (T eps=T(1.0e-7))
| this = normalized this
Vec3< T > | unit (T eps=0) const
| return normalized this, throws if null vector
Vec3< T > | unit (T eps, T &len) const
| return normalized this and length, throws if null vector
Vec3< T > | unitSafe () const
| return normalized this, or (1, 0, 0) if this is null vector
T | component (const Vec3< T > &onto, T eps=static_cast< T >(1.0e-7)) const
Vec3< T > | projection (const Vec3< T > &onto, T eps=static_cast< T >(1.0e-7)) const
Vec3< T > | getArbPerpendicular () const
Vec3< T > | sorted () const
| Return a vector with the components of this in ascending order.
Vec3< T > | reversed () const
| Return the vector (z, y, x)
T | operator[] (IdxT i) const
T & | operator[] (IdxT i)
T | operator[] (int i) const
T & | operator[] (int i)

## Static Public Member Functions
static unsigned | numRows ()
static unsigned | numColumns ()
static unsigned | numElements ()
static Vec3< T > | zero ()
| Predefined constants, e.g. Vec3d v = Vec3d::xNegAxis();.
static Vec3< T > | ones ()

## Static Public Attributes
static const int | size

## Compatibility
These are mostly for backwards compatibility with functions that take old-style Vs (which are just arrays).
void | toV (S *v) const
| Copies this tuple into an array of a compatible type.
value_type * | asV ()
| Exposes the internal array. Be careful when using this function.
value_type const * | asV () const
| Exposes the internal array. Be careful when using this function.
std::string | str () const
void | write (std::ostream &os) const
| Copies this tuple into an array of a compatible type.
void | read (std::istream &is)
| Copies this tuple into an array of a compatible type.
bool | isNan () const
| True if a Nan is present in this tuple.
bool | isInfinite () const
| True if an Inf is present in this tuple.
bool | isFinite () const
| True if no Nan or Inf values are present.
bool | isZero () const
| True if all elements are exactly zero.
T | mm [SIZE]
| Copies this tuple into an array of a compatible type.

## Member Typedef Documentation

## ◆ value_type

template<typename T >

using value_type = T

## ◆ ValueType

template<typename T >

using ValueType = T

## Constructor & Destructor Documentation

## ◆ Vec3() [1/7]

template<typename T >

Vec3 | ( |  | ) |
| default

Trivial constructor, the vector is NOT initialized

Note
  destructor, copy constructor, assignment operator and move constructor are left to be defined by the compiler (default)

## ◆ Vec3() [2/7]

template<typename T >

Vec3 | ( | T | val | ) |
| inlineexplicit

Construct a vector all of whose components have the given value.

## ◆ Vec3() [3/7]

template<typename T >

Vec3 | ( | T | x,
|  | T | y,
|  | T | z
| ) |  |
| inline

Constructor with three arguments, e.g. Vec3d v(1,2,3);.

## ◆ Vec3() [4/7]

template<typename T >
template<typename Source >

Vec3 | ( | Source * | a | ) |
| inline

Constructor with array argument, e.g. double a[3]; Vec3d v(a);.

## ◆ Vec3() [5/7]

template<typename T >
template<typename Source >

Vec3 | ( | const Tuple< 3, Source > & | v | ) |
| inlineexplicit

Construct a Vec3 from a 3-Tuple with a possibly different value type.

Type conversion warnings are suppressed.

## ◆ Vec3() [6/7]

template<typename T >
template<typename Other >

Vec3 | ( | Other | val,
|  | typename std::enable_if< std::is_arithmetic< Other >::value, Conversion >::type | = `Conversion{}`
| ) |  |
| inlineexplicit

Construct a vector all of whose components have the given value, which may be of an arithmetic type different from this vector's value type.

Type conversion warnings are suppressed.

## ◆ Vec3() [7/7]

template<typename T >
template<typename Other >

Vec3 | ( | const Vec3< Other > & | v | ) |
| inline

Construct a Vec3 from another Vec3 with a possibly different value type.

Type conversion warnings are suppressed.

## Member Function Documentation

## ◆ add()

template<typename T >
template<typename T0 , typename T1 >

const Vec3< T > & add | ( | const Vec3< T0 > & | v1,
|  | const Vec3< T1 > & | v2
| ) |  |
| inline

this = v1 + v2 "this", v1 and v2 need not be distinct objects, e.g. v.add(v1,v);

## ◆ asPointer() [1/2]

template<typename T >

T * asPointer | ( |  | ) |
| inline

## ◆ asPointer() [2/2]

template<typename T >

const T * asPointer | ( |  | ) | const
| inline

## ◆ asV() [1/2]

value_type * asV | ( |  | ) |
| inlineinherited

Exposes the internal array. Be careful when using this function.

## ◆ asV() [2/2]

value_type const * asV | ( |  | ) | const
| inlineinherited

Exposes the internal array. Be careful when using this function.

## ◆ component()

template<typename T >

T component | ( | const Vec3< T > & | onto,
|  | T | eps = `static_cast<T>(1.0e-7)`
| ) |  | const
| inline

Returns the scalar component of v in the direction of onto, onto need not be unit. e.g double c = Vec3d::component(v1,v2);

## ◆ cross() [1/2]

template<typename T >

Vec3< T > cross | ( | const Vec3< T > & | v | ) | const
| inline

Return the cross product of "this" vector and v;.

## ◆ cross() [2/2]

template<typename T >

const Vec3< T > & cross | ( | const Vec3< T > & | v1,
|  | const Vec3< T > & | v2
| ) |  |
| inline

this = v1 cross v2, v1 and v2 must be distinct objects than "this"

## ◆ div()

template<typename T >
template<typename T0 , typename T1 >

const Vec3< T > & div | ( | T0 | scale,
|  | const Vec3< T1 > & | v
| ) |  |
| inline

## ◆ dot()

template<typename T >

T dot | ( | const Vec3< T > & | v | ) | const
| inline

Dot product.

## ◆ eq()

template<typename T >

bool eq | ( | const Vec3< T > & | v,
|  | T | eps = `static_cast<T>(1.0e-7)`
| ) |  | const
| inline

Test if "this" vector is equivalent to vector v with tolerance of eps.

## ◆ exp()

template<typename T >

const Vec3< T > & exp | ( |  | ) |
| inline

Return a reference to itself after the exponent has been applied to all the vector components.

## ◆ getArbPerpendicular()

template<typename T >

Vec3< T > getArbPerpendicular | ( |  | ) | const
| inline

Return an arbitrary unit vector perpendicular to v Vector this must be a unit vector e.g. v = v.normalize(); Vec3d n = v.getArbPerpendicular();

## ◆ init()

template<typename T >

const Vec3< T > & init | ( | T | x = `0`,
|  | T | y = `0`,
|  | T | z = `0`
| ) |  |
| inline

"this" vector gets initialized to [x, y, z], calling v.init(); has same effect as calling v = Vec3::zero();

## ◆ isFinite()

bool isFinite | ( |  | ) | const
| inlineinherited

True if no Nan or Inf values are present.

## ◆ isInfinite()

bool isInfinite | ( |  | ) | const
| inlineinherited

True if an Inf is present in this tuple.

## ◆ isNan()

bool isNan | ( |  | ) | const
| inlineinherited

True if a Nan is present in this tuple.

## ◆ isZero()

bool isZero | ( |  | ) | const
| inlineinherited

True if all elements are exactly zero.

## ◆ length()

template<typename T >

T length | ( |  | ) | const
| inline

Length of the vector.

## ◆ lengthSqr()

template<typename T >

T lengthSqr | ( |  | ) | const
| inline

Squared length of the vector, much faster than length() as it does not involve square root

## ◆ log()

template<typename T >

const Vec3< T > & log | ( |  | ) |
| inline

Return a reference to itself after log has been applied to all the vector components.

## ◆ normalize()

template<typename T >

bool normalize | ( | T | eps = `T(1.0e-7)` | ) |
| inline

this = normalized this

## ◆ numColumns()

template<typename T >

static unsigned numColumns | ( |  | ) |
| inlinestatic

## ◆ numElements()

template<typename T >

static unsigned numElements | ( |  | ) |
| inlinestatic

## ◆ numRows()

template<typename T >

static unsigned numRows | ( |  | ) |
| inlinestatic

## ◆ ones()

template<typename T >

static Vec3< T > ones | ( |  | ) |
| inlinestatic

## ◆ operator()() [1/2]

template<typename T >

T & operator() | ( | int | i | ) |
| inline

Alternative indexed reference to the elements.

## ◆ operator()() [2/2]

template<typename T >

T operator() | ( | int | i | ) | const
| inline

Alternative indexed constant reference to the elements,.

## ◆ operator*=() [1/2]

template<typename T >
template<typename S >

const Vec3< T > & operator*= | ( | const Vec3< S > & | v1 | ) |
| inline

Multiply each element of this vector by the corresponding element of the given vector.

## ◆ operator*=() [2/2]

template<typename T >
template<typename S >

const Vec3< T > & operator*= | ( | S | scalar | ) |
| inline

Multiply each element of this vector by scalar.

## ◆ operator+=() [1/2]

template<typename T >
template<typename S >

const Vec3< T > & operator+= | ( | const Vec3< S > & | v1 | ) |
| inline

Add each element of the given vector to the corresponding element of this vector.

## ◆ operator+=() [2/2]

template<typename T >
template<typename S >

const Vec3< T > & operator+= | ( | S | scalar | ) |
| inline

Add scalar to each element of this vector.

## ◆ operator-()

template<typename T >

Vec3< T > operator- | ( |  | ) | const
| inline

Negation operator, for e.g. v1 = -v2;.

## ◆ operator-=() [1/2]

template<typename T >
template<typename S >

const Vec3< T > & operator-= | ( | const Vec3< S > & | v1 | ) |
| inline

Subtract each element of the given vector from the corresponding element of this vector.

## ◆ operator-=() [2/2]

template<typename T >
template<typename S >

const Vec3< T > & operator-= | ( | S | scalar | ) |
| inline

Subtract scalar from each element of this vector.

## ◆ operator/=() [1/2]

template<typename T >
template<typename S >

const Vec3< T > & operator/= | ( | const Vec3< S > & | v1 | ) |
| inline

Divide each element of this vector by the corresponding element of the given vector.

## ◆ operator/=() [2/2]

template<typename T >
template<typename S >

const Vec3< T > & operator/= | ( | S | scalar | ) |
| inline

Divide each element of this vector by scalar.

## ◆ operator=()

template<typename T >
template<typename Source >

const Vec3< T > & operator= | ( | const Vec3< Source > & | v | ) |
| inline

Assignment operator.

Type conversion warnings are not suppressed.

## ◆ operator[]() [1/4]

T & operator[] | ( | IdxT | i | ) |
| inlineinherited

## ◆ operator[]() [2/4]

T operator[] | ( | IdxT | i | ) | const
| inlineinherited

## ◆ operator[]() [3/4]

T & operator[] | ( | int | i | ) |
| inlineinherited

## ◆ operator[]() [4/4]

T operator[] | ( | int | i | ) | const
| inlineinherited

## ◆ product()

template<typename T >

T product | ( |  | ) | const
| inline

Return the product of all the vector components.

## ◆ projection()

template<typename T >

Vec3< T > projection | ( | const Vec3< T > & | onto,
|  | T | eps = `static_cast<T>(1.0e-7)`
| ) |  | const
| inline

Return the projection of v onto the vector, onto need not be unit e.g. Vec3d a = vprojection(n);

## ◆ read()

void read | ( | std::istream & | is | ) |
| inlineinherited

Copies this tuple into an array of a compatible type.

## ◆ reversed()

template<typename T >

Vec3< T > reversed | ( |  | ) | const
| inline

Return the vector (z, y, x)

## ◆ scale()

template<typename T >
template<typename T0 , typename T1 >

const Vec3< T > & scale | ( | T0 | scale,
|  | const Vec3< T1 > & | v
| ) |  |
| inline

this = scalar*v, v need not be a distinct object from "this", e.g. v.scale(1.5,v1);

## ◆ setZero()

template<typename T >

const Vec3< T > & setZero | ( |  | ) |
| inline

Set "this" vector to zero.

## ◆ sorted()

template<typename T >

Vec3< T > sorted | ( |  | ) | const
| inline

Return a vector with the components of this in ascending order.

## ◆ str()

std::string str | ( |  | ) | const
| inlineinherited

Returns
  string representation of Classname

## ◆ sub()

template<typename T >
template<typename T0 , typename T1 >

const Vec3< T > & sub | ( | const Vec3< T0 > & | v1,
|  | const Vec3< T1 > & | v2
| ) |  |
| inline

this = v1 - v2 "this", v1 and v2 need not be distinct objects, e.g. v.sub(v1,v);

## ◆ sum()

template<typename T >

T sum | ( |  | ) | const
| inline

Return the sum of all the vector components.

## ◆ toV()

void toV | ( | S * | v | ) | const
| inlineinherited

Copies this tuple into an array of a compatible type.

## ◆ unit() [1/2]

template<typename T >

Vec3< T > unit | ( | T | eps,
|  | T & | len
| ) |  | const
| inline

return normalized this and length, throws if null vector

## ◆ unit() [2/2]

template<typename T >

Vec3< T > unit | ( | T | eps = `0` | ) | const
| inline

return normalized this, throws if null vector

## ◆ unitSafe()

template<typename T >

Vec3< T > unitSafe | ( |  | ) | const
| inline

return normalized this, or (1, 0, 0) if this is null vector

## ◆ write()

void write | ( | std::ostream & | os | ) | const
| inlineinherited

Copies this tuple into an array of a compatible type.

## ◆ x() [1/2]

template<typename T >

T & x | ( |  | ) |
| inline

Reference to the component, e.g. v.x() = 4.5f;.

## ◆ x() [2/2]

template<typename T >

T x | ( |  | ) | const
| inline

Get the component, e.g. float f = v.y();.

## ◆ y() [1/2]

template<typename T >

T & y | ( |  | ) |
| inline

## ◆ y() [2/2]

template<typename T >

T y | ( |  | ) | const
| inline

## ◆ z() [1/2]

template<typename T >

T & z | ( |  | ) |
| inline

## ◆ z() [2/2]

template<typename T >

T z | ( |  | ) | const
| inline

## ◆ zero()

template<typename T >

static Vec3< T > zero | ( |  | ) |
| inlinestatic

Predefined constants, e.g. Vec3d v = Vec3d::xNegAxis();.

## Member Data Documentation

## ◆ mm

T mm[SIZE]
| protectedinherited

Copies this tuple into an array of a compatible type.

## ◆ size

const int size
| staticinherited